import binascii
import collections
import struct

Channel = collections.namedtuple(
    'Channel',
    'id name channel_type rate data_type')

channels = {}

def output_count(val, out):
    data = struct.pack("!I", val)
    out.write(data)
    out.flush()
    print binascii.hexlify(data)

def get_channels(indexes, out):
    global channels

    output_count(len(indexes), out)
    for i in indexes:
        channel = channels[i]
        data = "%s %s %s %s\0" % (channel.name, channel.channel_type, str(channel.rate), channel.data_type)
        output_count(len(data), out)
        out.write(data)
        out.flush()
        print data


def validate_action(action, args):
    if action == "register_chan" and len(args) == 5:
        return
    if action == "get-channels" and len(args) > 0:
        return

def execute_action(action, args, inp, out):
    global channels

    if action == "register_chan":
        chan = Channel(*args)
        channels[chan.id] = chan
    elif action == "get-channels":
        get_channels(args, out)
